﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Dfilter
{
    public partial class Form1 : Form
    {
        // staticなグローバル変数宣言
        static double pre1 = 0;
        static double pre2 = 0;
        static double A1 = 0;
        static double A2 = 0;
        static double B0 = 0;
        static double B1 = 0;
        static double B2 = 0;
        static int col = 0;
        static double dat = 0;
        static double res = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // OpenFileDialog の新しいインスタンスを生成する (デザイナから追加している場合は必要ない)
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            // ダイアログのタイトルを設定する
            openFileDialog1.Title = "データファイルの選択";

            // 初期表示するディレクトリを設定する
            openFileDialog1.InitialDirectory = @"C:\";

            // 初期表示するファイル名を設定する
            openFileDialog1.FileName = "初期表示するファイル名をココに書く";

            // ファイルのフィルタを設定する
            openFileDialog1.Filter = "csvファイル|*.csv;*.log|すべてのファイル|*.*";

            // ファイルの種類 の初期設定を 2 番目に設定する (初期値 1)
            openFileDialog1.FilterIndex = 1;

            // ダイアログボックスを閉じる前に現在のディレクトリを復元する (初期値 false)
            openFileDialog1.RestoreDirectory = true;

            // 複数のファイルを選択可能にする (初期値 false)
            openFileDialog1.Multiselect = false;

            // [ヘルプ] ボタンを表示する (初期値 false)
            openFileDialog1.ShowHelp = true;

            // [読み取り専用] チェックボックスを表示する (初期値 false)
            openFileDialog1.ShowReadOnly = true;

            // [読み取り専用] チェックボックスをオンにする (初期値 false)
            openFileDialog1.ReadOnlyChecked = true;

            // 存在しないファイルを指定した場合は警告を表示する (初期値 true)
            //openFileDialog1.CheckFileExists = true;

            // 存在しないパスを指定した場合は警告を表示する (初期値 true)
            //openFileDialog1.CheckPathExists = true;

            // 拡張子を指定しない場合は自動的に拡張子を付加する (初期値 true)
            //openFileDialog1.AddExtension = true;

            // 有効な Win32 ファイル名だけを受け入れるようにする (初期値 true)
            //openFileDialog1.ValidateNames = true;

            // ダイアログを表示し、戻り値が [OK] の場合は、選択したファイルを表示する
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //MessageBox.Show(openFileDialog1.FileName);

                // Multiselect が true の場合はこのように列挙する
                //foreach (string nFileName in openFileDialog1.FileNames) {
                //    MessageBox.Show(nFileName);
                //}

                // テキストボックスに表示
                this.textBox1.Text = openFileDialog1.FileName;
            }

            // 不要になった時点で破棄する (正しくは オブジェクトの破棄を保証する を参照)
            openFileDialog1.Dispose();
        }

        private void button1_Click(object sender, EventArgs e)
        {


            // デジタルフィルタ処理開始
            // 1.ファイル指定チェック
            if (this.textBox1.Text == "")
            {
                MessageBox.Show("ファイルが指定されていません");
                return;
            }
            // 2.列指定チェック
            if (this.textBox2.Text == "")
            {
                MessageBox.Show("列数が指定されていません");
                return;
            }
            else
            {
                col = int.Parse(this.textBox2.Text);
            }
            // 3.係数指定チェック
            if (this.textBox3.Text == "") { return; }
            if (this.textBox4.Text == "") { return; }
            if (this.textBox5.Text == "") { return; }
            if (this.textBox6.Text == "") { return; }
            if (this.textBox7.Text == "") { return; }

            A1 = double.Parse(this.textBox3.Text);
            A2 = double.Parse(this.textBox4.Text);
            B0 = double.Parse(this.textBox5.Text);
            B1 = double.Parse(this.textBox6.Text);
            B2 = double.Parse(this.textBox7.Text);

            // ファイル読み込み処理
            // StreamReader の新しいインスタンスを生成する
            System.IO.StreamReader cReader = (
                new System.IO.StreamReader(this.textBox1.Text, System.Text.Encoding.Default)
            );

            // 読み込んだ結果をすべて格納するための変数を宣言する
            string stResult = string.Empty;

            // hStream が破棄されることを保証するために using を使用する
            // 指定したパスのファイルを作成する

            string tmp = this.textBox1.Text + "_result.csv";

            FileStream fs = new FileStream(tmp, FileMode.Create);
            StreamWriter sw = new StreamWriter(fs);

            // 読み込みできる文字がなくなるまで繰り返す
            while (cReader.Peek() >= 0)
            {
                // ファイルを 1 行ずつ読み込む
                string stBuffer = cReader.ReadLine();
                // 読み込んだものを追加で格納する
                //stResult += stBuffer + System.Environment.NewLine;

                // カンマ区切りで抽出
                string[] stArrayData = stBuffer.Split(',');

                // 計算データの抽出
                dat = double.Parse(stArrayData[col - 1]);

                // BPF
                res = BPF(dat);

                // ファイル書き込み
                string str = dat.ToString() + "," + res.ToString();
                sw.WriteLine(str);
            }

            // cReader を閉じる (正しくは オブジェクトの破棄を保証する を参照)
            cReader.Close();
            sw.Close();

            // 結果を表示する
            //MessageBox.Show(stResult);
            //stResult = col.ToString();
            //stResult  = "A1=" + A1.ToString() + "\n";
            //stResult += "A2=" + A2.ToString() + "\n";
            //stResult += "B0=" + B0.ToString() + "\n";
            //stResult += "B1=" + B1.ToString() + "\n";
            //stResult += "B2=" + B2.ToString() + "\n";
            stResult = "フィルタリングが完了しました";
            MessageBox.Show(stResult);
        }

        private double BPF(double inp)
        {
            double reg, otp;

            reg = dat - (A1 * pre1) - (A2 * pre2);
            otp = (B0 * reg) + (B1 * pre1) + (B2 * pre2);

            pre2 = pre1;
            pre1 = reg;

            return otp;
        }
    }
}
